Index: /pjproject/trunk/pjsip/src/pjsip/sip_transport_loop.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsip/sip_transport_loop.c	(revision 107)
+++ /pjproject/trunk/pjsip/src/pjsip/sip_transport_loop.c	(revision 107)
@@ -0,0 +1,423 @@
+/* $Id$ */
+/* 
+ * Copyright (C) 2003-2006 Benny Prijono <benny@prijono.org>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
+#include <pjsip/sip_transport_loop.h>
+#include <pjsip/sip_endpoint.h>
+#include <pjsip/sip_errno.h>
+#include <pj/pool.h>
+#include <pj/os.h>
+#include <pj/string.h>
+#include <pj/lock.h>
+#include <pj/assert.h>
+#include <pj/compat/socket.h>
+
+
+#define FAIL_IMMEDIATE	1
+#define FAIL_CALLBACK	2
+
+#define ADDR_LOOP	"128.0.0.1"
+#define ADDR_LOOP_DGRAM	"129.0.0.1"
+
+
+/** This structure describes incoming packet. */
+struct recv_list
+{
+    PJ_DECL_LIST_MEMBER(struct recv_list);
+    pjsip_rx_data  rdata;
+};
+
+/** This structure is used to keep delayed send failure. */
+struct send_list
+{
+    PJ_DECL_LIST_MEMBER(struct send_list);
+    pj_time_val    sent_time;
+    pj_ssize_t	   sent;
+    pjsip_tx_data *tdata;
+    void	  *token;
+    void	 (*callback)(pjsip_transport*, void*, pj_ssize_t);
+};
+
+/** This structure describes the loop transport. */
+struct loop_transport
+{
+    pjsip_transport	     base;
+    pj_pool_t		    *pool;
+    pj_thread_t		    *thread;
+    pj_bool_t		     thread_quit_flag;
+    pj_bool_t		     discard;
+    int			     fail_mode;
+    unsigned		     delay;
+    struct recv_list	     recv_list;
+    struct send_list	     send_list;
+};
+
+
+/* Helper function to create "incoming" packet */
+struct recv_list *create_incoming_packet( struct loop_transport *loop,
+					  pjsip_tx_data *tdata )
+{
+    pj_pool_t *pool;
+    struct recv_list *pkt;
+
+    pool = pjsip_endpt_create_pool(loop->base.endpt, "rdata", 
+				   PJSIP_POOL_RDATA_LEN, PJSIP_POOL_RDATA_INC);
+    if (!pool)
+	return NULL;
+
+    pkt = pj_pool_zalloc(pool, sizeof(struct recv_list));
+
+    /* Initialize rdata. */
+    pkt->rdata.tp_info.pool = pool;
+    pkt->rdata.tp_info.transport = &loop->base;
+    
+    /* Copy the packet. */
+    pj_memcpy(pkt->rdata.pkt_info.packet, tdata->buf.start,
+	      tdata->buf.cur - tdata->buf.start);
+    pkt->rdata.pkt_info.len = tdata->buf.cur - tdata->buf.start;
+
+    /* "Source address" info. */
+    pkt->rdata.pkt_info.src_addr_len = sizeof(pj_sockaddr_in);
+    if (loop->base.key.type == PJSIP_TRANSPORT_LOOP)
+	pj_native_strcpy(pkt->rdata.pkt_info.src_name, ADDR_LOOP);
+    else
+	pj_native_strcpy(pkt->rdata.pkt_info.src_name, ADDR_LOOP_DGRAM);
+    pkt->rdata.pkt_info.src_port = loop->base.local_name.port;
+
+    /* When do we need to "deliver" this packet. */
+    pj_gettimeofday(&pkt->rdata.pkt_info.timestamp);
+    pkt->rdata.pkt_info.timestamp.msec += loop->delay;
+    pj_time_val_normalize(&pkt->rdata.pkt_info.timestamp);
+
+    /* Done. */
+
+    return pkt;
+}
+
+
+/* Helper function to add pending notification callback. */
+static pj_status_t add_notification( struct loop_transport *loop,
+				     pjsip_tx_data *tdata,
+				     pj_ssize_t sent,
+				     void *token,
+				     void (*callback)(pjsip_transport*, 
+						      void*, pj_ssize_t))
+{
+    struct send_list *sent_status;
+
+    pjsip_tx_data_add_ref(tdata);
+    pj_lock_acquire(tdata->lock);
+    sent_status = pj_pool_alloc(tdata->pool, sizeof(struct send_list));
+    pj_lock_release(tdata->lock);
+
+    sent_status->sent = sent;
+    sent_status->tdata = tdata;
+    sent_status->token = token;
+    sent_status->callback = callback;
+
+    pj_gettimeofday(&sent_status->sent_time);
+    sent_status->sent_time.msec += loop->delay;
+    pj_time_val_normalize(&sent_status->sent_time);
+
+    pj_lock_acquire(loop->base.lock);
+    pj_list_push_back(&loop->send_list, sent_status);
+    pj_lock_release(loop->base.lock);
+
+    return PJ_SUCCESS;
+}
+
+/* Handler for sending outgoing message; called by transport manager. */
+static pj_status_t loop_send_msg( pjsip_transport *tp, 
+				  pjsip_tx_data *tdata,
+				  const pj_sockaddr_t *rem_addr,
+				  int addr_len,
+				  void *token,
+				  void (*cb)(pjsip_transport *transport,
+					     void *token, 
+					     pj_ssize_t sent_bytes))
+{
+    struct loop_transport *loop = (struct loop_transport*)tp;
+    struct recv_list *recv_pkt;
+    
+    PJ_ASSERT_RETURN(tp && (tp->key.type == PJSIP_TRANSPORT_LOOP ||
+	             tp->key.type == PJSIP_TRANSPORT_LOOP_DGRAM), PJ_EINVAL);
+
+    PJ_UNUSED_ARG(rem_addr);
+    PJ_UNUSED_ARG(addr_len);
+
+
+    /* Need to send failure immediately? */
+    if (loop->fail_mode == FAIL_IMMEDIATE) {
+	return PJ_STATUS_FROM_OS(OSERR_ECONNRESET);
+
+    /* Need to send failure later? */
+    } else if (loop->fail_mode == FAIL_CALLBACK) {
+
+	add_notification(loop, tdata, -PJ_STATUS_FROM_OS(OSERR_ECONNRESET), 
+			 token, cb);
+
+	return PJ_EPENDING;
+    }
+
+    /* Discard any packets? */
+    if (loop->discard)
+	return PJ_SUCCESS;
+
+    /* Create rdata for the "incoming" packet. */
+    recv_pkt = create_incoming_packet(loop, tdata);
+    if (!recv_pkt)
+	return PJ_ENOMEM;
+
+    /* If delay is not configured, deliver this packet now! */
+    if (loop->delay == 0) {
+	pj_ssize_t size_eaten;
+
+	size_eaten = pjsip_tpmgr_receive_packet( loop->base.tpmgr, 
+						 &recv_pkt->rdata);
+	pj_assert(size_eaten == recv_pkt->rdata.pkt_info.len);
+
+	pjsip_endpt_release_pool(loop->base.endpt, 
+				 recv_pkt->rdata.tp_info.pool);
+	return PJ_SUCCESS;
+
+    } else {
+	/* Otherwise if delay is configured, add the "packet" to the 
+	 * receive list to be processed by worker thread, and add
+	 * pending notification for calling the callback.
+	 */
+	add_notification(loop, tdata, tdata->buf.cur - tdata->buf.start, 
+			 token, cb);
+
+	pj_lock_acquire(loop->base.lock);
+	pj_list_push_back(&loop->recv_list, recv_pkt);
+	pj_lock_release(loop->base.lock);
+	return PJ_EPENDING;
+    }
+}
+
+/* Handler to destroy the transport; called by transport manager */
+static pj_status_t loop_destroy(pjsip_transport *tp)
+{
+    struct loop_transport *loop = (struct loop_transport*)tp;
+    
+    PJ_ASSERT_RETURN(tp && (tp->key.type == PJSIP_TRANSPORT_LOOP ||
+	             tp->key.type == PJSIP_TRANSPORT_LOOP_DGRAM), PJ_EINVAL);
+    
+    loop->thread_quit_flag = 1;
+    /* Unlock transport mutex before joining thread. */
+    pj_lock_release(tp->lock);
+    pj_thread_join(loop->thread);
+    pj_thread_destroy(loop->thread);
+
+    pj_lock_destroy(loop->base.lock);
+    pj_atomic_destroy(loop->base.ref_cnt);
+    pjsip_endpt_release_pool(loop->base.endpt, loop->base.pool);
+
+    return PJ_SUCCESS;
+}
+
+/* Worker thread for loop transport. */
+static int loop_thread(void *arg)
+{
+    struct loop_transport *loop = arg;
+
+    while (!loop->thread_quit_flag) {
+	pj_time_val now;
+
+	pj_thread_sleep(10);
+	pj_gettimeofday(&now);
+
+	pj_lock_acquire(loop->base.lock);
+
+	/* Process pending send notification. */
+	while (!pj_list_empty(&loop->send_list)) {
+	    struct send_list *node = loop->send_list.next;
+
+	    /* Break when next node time is greater than now. */
+	    if (PJ_TIME_VAL_GTE(node->sent_time, now))
+		break;
+
+	    /* Notify callback. */
+	    if (node->callback) {
+		(*node->callback)(&loop->base, node->token, node->sent);
+	    }
+
+	    /* Delete this from the list. */
+	    pj_list_erase(node);
+
+	    /* Decrement tdata reference counter. */
+	    pjsip_tx_data_dec_ref(node->tdata);
+	}
+
+	/* Process "incoming" packets. */
+	while (!pj_list_empty(&loop->recv_list)) {
+	    struct recv_list *node = loop->recv_list.next;
+	    pj_ssize_t size_eaten;
+
+	    /* Break when next node time is greater than now. */
+	    if (PJ_TIME_VAL_GTE(node->rdata.pkt_info.timestamp, now))
+		break;
+
+	    /* Notify transport manager about the "incoming packet" */
+	    size_eaten = pjsip_tpmgr_receive_packet(loop->base.tpmgr,
+						    &node->rdata);
+
+	    /* Must "eat" all the packets. */
+	    pj_assert(size_eaten == node->rdata.pkt_info.len);
+
+	    /* Delete this from the list. */
+	    pj_list_erase(node);
+
+	    /* Done. */
+	    pjsip_endpt_release_pool(loop->base.endpt,
+				     node->rdata.tp_info.pool);
+	}
+
+	pj_lock_release(loop->base.lock);
+    }
+
+    return 0;
+}
+
+
+/* Start loop transport. */
+PJ_DEF(pj_status_t) pjsip_loop_start( pjsip_endpoint *endpt,
+				      pjsip_transport **transport)
+{
+    pj_pool_t *pool;
+    struct loop_transport *loop;
+    pj_status_t status;
+
+    /* Create pool. */
+    pool = pjsip_endpt_create_pool(endpt, "loop", 4000, 4000);
+    if (!pool)
+	return PJ_ENOMEM;
+
+    /* Create the loop structure. */
+    loop = pj_pool_zalloc(pool, sizeof(struct loop_transport));
+    
+    /* Initialize transport properties. */
+    pj_sprintf(loop->base.obj_name, "loop%p", loop);
+    loop->base.pool = pool;
+    status = pj_atomic_create(pool, 0, &loop->base.ref_cnt);
+    if (status != PJ_SUCCESS)
+	goto on_error;
+    status = pj_lock_create_recursive_mutex(pool, "loop", &loop->base.lock);
+    if (status != PJ_SUCCESS)
+	goto on_error;
+    loop->base.key.type = PJSIP_TRANSPORT_LOOP_DGRAM;
+    loop->base.key.rem_addr.sa_family = PJ_AF_INET;
+    loop->base.type_name = "LOOP-DGRAM";
+    loop->base.info = "LOOP-DGRAM";
+    loop->base.flag = PJSIP_TRANSPORT_DATAGRAM;
+    loop->base.local_name.host = pj_str(ADDR_LOOP_DGRAM);
+    loop->base.local_name.port = 
+	pjsip_transport_get_default_port_for_type(loop->base.key.type);
+    loop->base.addr_len = sizeof(pj_sockaddr_in);
+    loop->base.endpt = endpt;
+    loop->base.tpmgr = pjsip_endpt_get_tpmgr(endpt);
+    loop->base.send_msg = &loop_send_msg;
+    loop->base.destroy = &loop_destroy;
+
+    pj_list_init(&loop->recv_list);
+    pj_list_init(&loop->send_list);
+
+    /* Create worker thread. */
+    status = pj_thread_create(pool, "loop", &loop_thread, loop, 0, 
+			      PJ_THREAD_SUSPENDED, &loop->thread);
+    if (status != PJ_SUCCESS)
+	goto on_error;
+
+    /* Register to transport manager. */
+    status = pjsip_transport_register( loop->base.tpmgr, &loop->base);
+    if (status != PJ_SUCCESS)
+	goto on_error;
+
+    /* Start the thread. */
+    status = pj_thread_resume(loop->thread);
+    if (status != PJ_SUCCESS)
+	goto on_error;
+
+    /*
+     * Done.
+     */
+
+    *transport = &loop->base;
+    return PJ_SUCCESS;
+
+on_error:
+    if (loop->base.lock)
+	pj_lock_destroy(loop->base.lock);
+    if (loop->thread)
+	pj_thread_destroy(loop->thread);
+    if (loop->base.ref_cnt)
+	pj_atomic_destroy(loop->base.ref_cnt);
+    pjsip_endpt_release_pool(endpt, loop->pool);
+    return status;
+}
+
+
+PJ_DEF(pj_status_t) pjsip_loop_set_discard( pjsip_transport *tp,
+					    pj_bool_t discard,
+					    pj_bool_t *prev_value )
+{
+    struct loop_transport *loop = (struct loop_transport*)tp;
+
+    PJ_ASSERT_RETURN(tp && (tp->key.type == PJSIP_TRANSPORT_LOOP ||
+	             tp->key.type == PJSIP_TRANSPORT_LOOP_DGRAM), PJ_EINVAL);
+
+    if (prev_value)
+	*prev_value = loop->discard;
+    loop->discard = discard;
+
+    return PJ_SUCCESS;
+}
+
+
+PJ_DEF(pj_status_t) pjsip_loop_set_failure( pjsip_transport *tp,
+					    int fail_flag,
+					    int *prev_value )
+{
+    struct loop_transport *loop = (struct loop_transport*)tp;
+
+    PJ_ASSERT_RETURN(tp && (tp->key.type == PJSIP_TRANSPORT_LOOP ||
+	             tp->key.type == PJSIP_TRANSPORT_LOOP_DGRAM), PJ_EINVAL);
+
+    if (prev_value)
+	*prev_value = loop->fail_mode;
+    loop->fail_mode = fail_flag;
+
+    return PJ_SUCCESS;
+}
+
+
+PJ_DEF(pj_status_t) pjsip_loop_set_delay( pjsip_transport *tp,
+					  unsigned delay,
+					  unsigned *prev_value)
+{
+    struct loop_transport *loop = (struct loop_transport*)tp;
+
+    PJ_ASSERT_RETURN(tp && (tp->key.type == PJSIP_TRANSPORT_LOOP ||
+	             tp->key.type == PJSIP_TRANSPORT_LOOP_DGRAM), PJ_EINVAL);
+
+    if (prev_value)
+	*prev_value = loop->delay;
+    loop->delay = delay;
+
+    return PJ_SUCCESS;
+}
+
Index: /pjproject/trunk/pjsip/src/pjsip/sip_transport_udp.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsip/sip_transport_udp.c	(revision 106)
+++ /pjproject/trunk/pjsip/src/pjsip/sip_transport_udp.c	(revision 107)
@@ -1,3 +1,3 @@
-/* $Id: $ */
+/* $Id$ */
 /* 
  * Copyright (C) 2003-2006 Benny Prijono <benny@prijono.org>
@@ -193,4 +193,5 @@
     struct udp_transport *tp = (struct udp_transport*)transport;
     pj_ssize_t size;
+    pj_status_t status;
 
     PJ_ASSERT_RETURN(transport && tdata, PJ_EINVAL);
@@ -204,7 +205,12 @@
     /* Send to ioqueue! */
     size = tdata->buf.cur - tdata->buf.start;
-    return pj_ioqueue_sendto(tp->key, (pj_ioqueue_op_key_t*)&tdata->op_key,
-			     tdata->buf.start, &size, 0,
-			     rem_addr, addr_len);
+    status = pj_ioqueue_sendto(tp->key, (pj_ioqueue_op_key_t*)&tdata->op_key,
+			       tdata->buf.start, &size, 0,
+			       rem_addr, addr_len);
+
+    if (status != PJ_EPENDING)
+	tdata->op_key.tdata = NULL;
+
+    return status;
 }
 
@@ -245,5 +251,5 @@
 
     /* Destroy pool. */
-    pjsip_endpt_destroy_pool(tp->base.endpt, tp->base.pool);
+    pjsip_endpt_release_pool(tp->base.endpt, tp->base.pool);
 
     return PJ_SUCCESS;
@@ -420,5 +426,6 @@
 
     /* Done. */
-    *p_transport = &tp->base;
+    if (p_transport)
+	*p_transport = &tp->base;
     return PJ_SUCCESS;
 
Index: /pjproject/trunk/pjsip/src/pjsip/sip_util.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsip/sip_util.c	(revision 106)
+++ /pjproject/trunk/pjsip/src/pjsip/sip_util.c	(revision 107)
@@ -177,6 +177,5 @@
 	target = pjsip_parse_uri( tdata->pool, tmp.ptr, tmp.slen, 0);
 	if (target == NULL) {
-	    PJ_LOG(4,(THIS_FILE, "Error creating request: invalid target %s", 
-		      tmp.ptr));
+	    status = PJSIP_EINVALIDREQURI;
 	    goto on_error;
 	}
@@ -188,6 +187,5 @@
 				     PJSIP_PARSE_URI_AS_NAMEADDR);
 	if (from->uri == NULL) {
-	    PJ_LOG(4,(THIS_FILE, "Error creating request: invalid 'From' URI '%s'",
-				tmp.ptr));
+	    status = PJSIP_EINVALIDHDR;
 	    goto on_error;
 	}
@@ -200,6 +198,5 @@
 				   PJSIP_PARSE_URI_AS_NAMEADDR);
 	if (to->uri == NULL) {
-	    PJ_LOG(4,(THIS_FILE, "Error creating request: invalid 'To' URI '%s'",
-				tmp.ptr));
+	    status = PJSIP_EINVALIDHDR;
 	    goto on_error;
 	}
@@ -212,7 +209,5 @@
 					    PJSIP_PARSE_URI_AS_NAMEADDR);
 	    if (contact->uri == NULL) {
-		PJ_LOG(4,(THIS_FILE, 
-			  "Error creating request: invalid 'Contact' URI '%s'",
-			  tmp.ptr));
+		status = PJSIP_EINVALIDHDR;
 		goto on_error;
 	    }
@@ -1170,5 +1165,5 @@
 	    return PJ_SUCCESS;
 	} else {
-	    send_response_transport_cb(send_state, tdata, -status);
+	    pjsip_transport_dec_ref(send_state->cur_transport);
 	    return status;
 	}
@@ -1180,4 +1175,55 @@
 }
 
+/*
+ * Send response
+ */
+PJ_DEF(pj_status_t) pjsip_endpt_respond_stateless( pjsip_endpoint *endpt,
+						   pjsip_rx_data *rdata,
+						   int st_code,
+						   const pj_str_t *st_text,
+						   const pjsip_hdr *hdr_list,
+						   const pjsip_msg_body *body)
+{
+    pj_status_t status;
+    pjsip_response_addr res_addr;
+    pjsip_tx_data *tdata;
+
+    /* Create response message */
+    status = pjsip_endpt_create_response( endpt, rdata, st_code, st_text, 
+					  &tdata);
+    if (status != PJ_SUCCESS)
+	return status;
+
+    /* Add the message headers, if any */
+    if (hdr_list) {
+	const pjsip_hdr *hdr = hdr_list->next;
+	while (hdr != hdr_list) {
+	    pjsip_msg_add_hdr( tdata->msg, pjsip_hdr_clone(tdata->pool, hdr) );
+	    hdr = hdr->next;
+	}
+    }
+
+    /* Add the message body, if any. */
+    if (body) {
+	tdata->msg->body = pj_pool_alloc(tdata->pool, sizeof(pjsip_msg_body));
+	status = pjsip_msg_body_clone( tdata->pool, tdata->msg->body, body );
+	if (status != PJ_SUCCESS) {
+	    pjsip_tx_data_dec_ref(tdata);
+	    return status;
+	}
+    }
+
+    /* Get where to send request. */
+    status = pjsip_get_response_addr( tdata->pool, rdata, &res_addr );
+    if (status != PJ_SUCCESS) {
+	pjsip_tx_data_dec_ref(tdata);
+	return status;
+    }
+
+    /* Send! */
+    status = pjsip_endpt_send_response( endpt, &res_addr, tdata, NULL, NULL );
+
+    return status;
+}
 
 /*
Index: /pjproject/trunk/pjsip/src/pjsip/sip_util_proxy.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsip/sip_util_proxy.c	(revision 107)
+++ /pjproject/trunk/pjsip/src/pjsip/sip_util_proxy.c	(revision 107)
@@ -0,0 +1,66 @@
+/* $Id$ */
+/* 
+ * Copyright (C) 2003-2006 Benny Prijono <benny@prijono.org>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
+#include <pjsip/sip_util.h>
+#include <pjsip/sip_errno.h>
+#include <pj/assert.h>
+
+PJ_DEF(pj_status_t) pjsip_endpt_create_request_fwd(  pjsip_endpoint *endpt,
+						     pjsip_rx_data *rdata, 
+						     const pjsip_uri *uri,
+						     const pj_str_t *branch,
+						     unsigned options,
+						     pjsip_tx_data **tdata)
+{
+    PJ_UNUSED_ARG(endpt);
+    PJ_UNUSED_ARG(rdata);
+    PJ_UNUSED_ARG(uri);
+    PJ_UNUSED_ARG(branch);
+    PJ_UNUSED_ARG(options);
+    PJ_UNUSED_ARG(tdata);
+
+    pj_assert(!"Not implemented yet");
+    return PJ_EBUG;
+}
+
+
+PJ_DEF(pj_status_t) pjsip_endpt_create_response_fwd( pjsip_endpoint *endpt,
+						     pjsip_rx_data *rdata, 
+						     unsigned options,
+						     pjsip_tx_data **tdata)
+{
+    PJ_UNUSED_ARG(endpt);
+    PJ_UNUSED_ARG(rdata);
+    PJ_UNUSED_ARG(options);
+    PJ_UNUSED_ARG(tdata);
+
+    pj_assert(!"Not implemented yet");
+    return PJ_EBUG;
+}
+
+
+PJ_DEF(pj_str_t) pjsip_calculate_branch_id( pjsip_rx_data *rdata )
+{
+    pj_str_t empty_str = { NULL, 0 };
+
+    PJ_UNUSED_ARG(rdata);
+    pj_assert(!"Not implemented yet");
+    return empty_str;
+}
+
+
Index: /pjproject/trunk/pjsip/src/test-pjsip/msg_test.c
===================================================================
--- /pjproject/trunk/pjsip/src/test-pjsip/msg_test.c	(revision 106)
+++ /pjproject/trunk/pjsip/src/test-pjsip/msg_test.c	(revision 107)
@@ -48,5 +48,5 @@
     /* 'Normal' message with all headers. */
     "INVITE sip:user@foo SIP/2.0\n"
-    "From: Hi I'm Joe <sip:joe.user@bar.otherdomain.com>;tag=1234578901234567890\r"
+    "From: Hi I'm Joe <sip:joe.user@bar.otherdomain.com>;tag=123457890123456\r"
     "To: Fellow User <sip:user@foo.bar.domain.com>\r\n"
     "Call-ID: 12345678901234567890@bar\r\n"
@@ -58,13 +58,14 @@
     "Route: <sip:bigbox3.site3.atlanta.com;lr>,\r\n"
     "  <sip:server10.biloxi.com;lr>\r"
-    "Record-Route: <sip:server10.biloxi.com>,\r\n"
+    "Record-Route: <sip:server10.biloxi.com>,\r\n" /* multiple routes+folding*/
     "  <sip:bigbox3.site3.atlanta.com;lr>\n"
-    "Via: SIP/2.0/SCTP bigbox3.site3.atlanta.com;branch=z9hG4bK77ef4c2312983.1\n"
-    "Via: SIP/2.0/UDP pc33.atlanta.com;branch=z9hG4bKnashds8\n"
+    "Via: SIP/2.0/SCTP bigbox3.site3.atlanta.com;branch=z9hG4bK77ef4c230\n"
+    "Via: SIP/2.0/UDP pc33.atlanta.com;branch=z9hG4bKnashds8\n" /* folding. */
     " ;received=192.0.2.1\r\n"
     "Via: SIP/2.0/UDP 10.2.1.1, SIP/2.0/TCP 192.168.1.1\n"
     "Organization: \r"
     "Max-Forwards: 70\n"
-    "X-Header: \r\n"
+    "X-Header: \r\n"	    /* empty header */
+    "P-Associated-URI:\r\n" /* empty header without space */
     "\r\n",
     &create_msg0,
@@ -352,8 +353,8 @@
     pj_strdup2(pool, &url->host, "foo");
 
-    /* "From: Hi I'm Joe <sip:joe.user@bar.otherdomain.com>;tag=1234578901234567890\r" */
+    /* "From: Hi I'm Joe <sip:joe.user@bar.otherdomain.com>;tag=123457890123456\r" */
     fromto = pjsip_from_hdr_create(pool);
     pjsip_msg_add_hdr(msg, (pjsip_hdr*)fromto);
-    pj_strdup2(pool, &fromto->tag, "1234578901234567890");
+    pj_strdup2(pool, &fromto->tag, "123457890123456");
     name_addr = pjsip_name_addr_create(pool);
     fromto->uri = (pjsip_uri*)name_addr;
@@ -463,10 +464,10 @@
     url->lr_param = 1;
 
-    /* "Via: SIP/2.0/SCTP bigbox3.site3.atlanta.com;branch=z9hG4bK77ef4c2312983.1\n" */
+    /* "Via: SIP/2.0/SCTP bigbox3.site3.atlanta.com;branch=z9hG4bK77ef4c230\n" */
     via = pjsip_via_hdr_create(pool);
     pjsip_msg_add_hdr(msg, (pjsip_hdr*)via);
     pj_strdup2(pool, &via->transport, "SCTP");
     pj_strdup2(pool, &via->sent_by.host, "bigbox3.site3.atlanta.com");
-    pj_strdup2(pool, &via->branch_param, "z9hG4bK77ef4c2312983.1");
+    pj_strdup2(pool, &via->branch_param, "z9hG4bK77ef4c230");
 
     /* "Via: SIP/2.0/UDP pc33.atlanta.com;branch=z9hG4bKnashds8\n"
@@ -513,4 +514,13 @@
     str.ptr = "X-Header";
     str.slen = 8;
+    generic = pjsip_generic_string_hdr_create(pool, &str);
+    pjsip_msg_add_hdr(msg, (pjsip_hdr*)generic);
+    str.ptr = NULL;
+    str.slen = 0;
+    generic->hvalue = str;
+
+    /* P-Associated-URI:\r\n */
+    str.ptr = "P-Associated-URI";
+    str.slen = 16;
     generic = pjsip_generic_string_hdr_create(pool, &str);
     pjsip_msg_add_hdr(msg, (pjsip_hdr*)generic);
@@ -678,5 +688,5 @@
 	pool = pjsip_endpt_create_pool(endpt, NULL, POOL_SIZE, POOL_SIZE);
 	status = test_entry( pool, &test_array[i] );
-	pjsip_endpt_destroy_pool(endpt, pool);
+	pjsip_endpt_release_pool(endpt, pool);
 
 	if (status != PJ_SUCCESS)
@@ -692,5 +702,5 @@
 	    pool = pjsip_endpt_create_pool(endpt, NULL, POOL_SIZE, POOL_SIZE);
 	    status = test_entry( pool, &test_array[i] );
-	    pjsip_endpt_destroy_pool(endpt, pool);
+	    pjsip_endpt_release_pool(endpt, pool);
 
 	    if (status != PJ_SUCCESS)
Index: /pjproject/trunk/pjsip/src/test-pjsip/test.c
===================================================================
--- /pjproject/trunk/pjsip/src/test-pjsip/test.c	(revision 106)
+++ /pjproject/trunk/pjsip/src/test-pjsip/test.c	(revision 107)
@@ -82,8 +82,10 @@
     PJ_LOG(3,("",""));
 
-    DO_TEST(uri_test());
-    DO_TEST(msg_test());
-    DO_TEST(txdata_test());
-    DO_TEST(transport_udp_test());
+    //DO_TEST(uri_test());
+    //DO_TEST(msg_test());
+    //DO_TEST(txdata_test());
+    //DO_TEST(transport_udp_test());
+    DO_TEST(transport_loop_test());
+    //DO_TEST(tsx_uac_test());
 
 on_return:
Index: /pjproject/trunk/pjsip/src/test-pjsip/test.h
===================================================================
--- /pjproject/trunk/pjsip/src/test-pjsip/test.h	(revision 106)
+++ /pjproject/trunk/pjsip/src/test-pjsip/test.h	(revision 107)
@@ -24,5 +24,6 @@
 extern pjsip_endpoint *endpt;
 
-#define TEST_UDP_PORT	15060
+#define TEST_UDP_PORT	    15060
+#define TEST_UDP_PORT_STR   "15060"
 
 /* The tests */
@@ -31,4 +32,6 @@
 int txdata_test(void);
 int transport_udp_test(void);
+int transport_loop_test(void);
+int tsx_uac_test(void);
 
 /* Transport test helpers (transport_test.c). */
@@ -36,8 +39,8 @@
 int transport_send_recv_test( pjsip_transport_type_e tp_type,
 			      pjsip_transport *ref_tp,
-			      const pj_sockaddr_in *rem_addr );
+			      char *target_url );
 int transport_rt_test( pjsip_transport_type_e tp_type,
 		       pjsip_transport *ref_tp,
-		       const pj_sockaddr_in *rem_addr );
+		       char *target_url );
 
 /* Test main entry */
Index: /pjproject/trunk/pjsip/src/test-pjsip/transport_loop_test.c
===================================================================
--- /pjproject/trunk/pjsip/src/test-pjsip/transport_loop_test.c	(revision 107)
+++ /pjproject/trunk/pjsip/src/test-pjsip/transport_loop_test.c	(revision 107)
@@ -0,0 +1,127 @@
+/* $Id$ */
+/* 
+ * Copyright (C) 2003-2006 Benny Prijono <benny@prijono.org>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
+
+#include "test.h"
+#include <pjsip_core.h>
+#include <pjlib.h>
+
+static int datagram_loop_test()
+{
+    pjsip_transport *loop, *tp;
+    pj_str_t s;
+    int i, log_level;
+    pj_sockaddr_in addr;
+    pj_status_t status;
+
+    PJ_LOG(3,("", "testing datagram loop transport"));
+
+    /* Create loop transport. */
+    status = pjsip_loop_start(endpt, &loop);
+    if (status != PJ_SUCCESS) {
+	app_perror("   error: unable to create datagram loop transport", 
+		   status);
+	return -10;
+    }
+
+    /* Create dummy address. */
+    pj_sockaddr_in_init(&addr, pj_cstr(&s, "130.0.0.1"), TEST_UDP_PORT);
+
+    /* Test acquire transport. */
+    status = pjsip_endpt_acquire_transport( endpt, PJSIP_TRANSPORT_LOOP_DGRAM,
+					    &addr, sizeof(addr), &tp);
+    if (status != PJ_SUCCESS) {
+	app_perror("   error: unable to acquire transport", status);
+	return -20;
+    }
+
+    /* Check that this is the right transport. */
+    if (tp != loop) {
+	return -30;
+    }
+
+    /* Test basic transport attributes */
+    status = generic_transport_test(loop);
+    if (status != PJ_SUCCESS)
+	return status;
+
+    /* Basic transport's send/receive loopback test. */
+    for (i=0; i<2; ++i) {
+	status = transport_send_recv_test(PJSIP_TRANSPORT_LOOP_DGRAM, loop, 
+					  "sip:bob@130.0.0.1;transport=loop-dgram");
+	if (status != 0)
+	    return status;
+    }
+
+    /* For multithreaded round-trip test to work, delay must be set
+     * (otherwise functions will be called recursively until no memory is
+     * left in the system)
+     */
+
+    /* Put delay. */
+    pjsip_loop_set_delay(loop, 1, NULL);
+
+    /* Multi-threaded round-trip test. */
+    status = transport_rt_test(PJSIP_TRANSPORT_LOOP_DGRAM, tp, 
+			       "sip:bob@130.0.0.1;transport=loop-dgram");
+    if (status != 0)
+	return status;
+
+
+    /* Next test will test without delay.
+     * This will stress-test the system.
+     */
+    PJ_LOG(3,("","  performing another multithreaded round-trip test..."));
+
+    /* Remove delay. */
+    pjsip_loop_set_delay(loop, 0, NULL);
+
+    /* Ignore errors. */
+    log_level = pj_log_get_level();
+    pj_log_set_level(2);
+
+    /* Multi-threaded round-trip test. */
+    status = transport_rt_test(PJSIP_TRANSPORT_LOOP_DGRAM, tp, 
+			       "sip:bob@130.0.0.1;transport=loop-dgram");
+    if (status != 0)
+	return status;
+
+    /* Restore log level. */
+    pj_log_set_level(log_level);
+
+    /* Check that reference counter is one. */
+    if (pj_atomic_get(loop->ref_cnt) != 1) {
+	return -30;
+    }
+
+    /* Decrement reference. */
+    pjsip_transport_dec_ref(loop);
+
+    return 0;
+}
+
+int transport_loop_test(void)
+{
+    int status;
+
+    status = datagram_loop_test();
+    if (status != 0)
+	return status;
+
+    return 0;
+}
Index: /pjproject/trunk/pjsip/src/test-pjsip/transport_test.c
===================================================================
--- /pjproject/trunk/pjsip/src/test-pjsip/transport_test.c	(revision 106)
+++ /pjproject/trunk/pjsip/src/test-pjsip/transport_test.c	(revision 107)
@@ -76,5 +76,4 @@
  */
 #define FROM_HDR    "Bob <sip:bob@example.com>"
-#define TO_HDR	    "Alice <sip:alice@example.com>"
 #define CONTACT_HDR "Bob <sip:bob@127.0.0.1>"
 #define CALL_ID_HDR "SendRecv-Test"
@@ -109,5 +108,5 @@
     &my_on_rx_request,			/* on_rx_request()	*/
     &my_on_rx_response,			/* on_rx_response()	*/
-    NULL,				/* tsx_handler()	*/
+    NULL,				/* on_tsx_state()	*/
 };
 
@@ -189,8 +188,7 @@
 int transport_send_recv_test( pjsip_transport_type_e tp_type,
 			      pjsip_transport *ref_tp,
-			      const pj_sockaddr_in *rem_addr )
+			      char *target_url )
 {
     pj_status_t status;
-    char target_buf[80];
     pj_str_t target, from, to, contact, call_id, body;
     pjsip_method method;
@@ -210,9 +208,7 @@
 
     /* Create a request message. */
-    pj_sprintf(target_buf, "sip:%s:%d", pj_inet_ntoa(rem_addr->sin_addr),
-					pj_ntohs(rem_addr->sin_port));
-    target = pj_str(target_buf);
+    target = pj_str(target_url);
     from = pj_str(FROM_HDR);
-    to = pj_str(TO_HDR);
+    to = pj_str(target_url);
     contact = pj_str(CONTACT_HDR);
     call_id = pj_str(CALL_ID_HDR);
@@ -334,5 +330,5 @@
 } rt_test_data[16];
 
-static char	 rt_target_uri[32];
+static char	 rt_target_uri[64];
 static pj_bool_t rt_stop;
 static pj_str_t  rt_call_id;
@@ -350,8 +346,10 @@
 	status = pjsip_endpt_create_response( endpt, rdata, 200, NULL, &tdata);
 	if (status != PJ_SUCCESS) {
+	    app_perror("    error creating response", status);
 	    return PJ_TRUE;
 	}
 	status = pjsip_get_response_addr( tdata->pool, rdata, &res_addr);
 	if (status != PJ_SUCCESS) {
+	    app_perror("    error in get response address", status);
 	    pjsip_tx_data_dec_ref(tdata);
 	    return PJ_TRUE;
@@ -359,4 +357,5 @@
 	status = pjsip_endpt_send_response( endpt, &res_addr, tdata, NULL, NULL);
 	if (status != PJ_SUCCESS) {
+	    app_perror("    error sending response", status);
 	    pjsip_tx_data_dec_ref(tdata);
 	    return PJ_TRUE;
@@ -377,5 +376,5 @@
     target = pj_str(rt_target_uri);
     from = pj_str(FROM_HDR);
-    to = pj_str(TO_HDR);
+    to = pj_str(rt_target_uri);
     contact = pj_str(CONTACT_HDR);
     call_id = rt_test_data[thread_id].call_id;
@@ -431,5 +430,5 @@
 static int rt_thread(void *arg)
 {
-    int thread_id = (int)arg;
+    int i, thread_id = (int)arg;
     pj_time_val poll_delay = { 0, 10 };
 
@@ -444,4 +443,9 @@
 	pjsip_endpt_handle_events(endpt, &poll_delay);
     }
+
+    /* Exhaust responses. */
+    for (i=0; i<100; ++i)
+	pjsip_endpt_handle_events(endpt, &poll_delay);
+
     return 0;
 }
@@ -449,5 +453,5 @@
 int transport_rt_test( pjsip_transport_type_e tp_type,
 		       pjsip_transport *ref_tp,
-		       const pj_sockaddr_in *rem_addr )
+		       char *target_url )
 {
     enum { THREADS = 4, INTERVAL = 10 };
@@ -484,6 +488,5 @@
 
     /* Initialize static test data. */
-    pj_sprintf(rt_target_uri, "sip:%s:%d", pj_inet_ntoa(rem_addr->sin_addr),
-					   pj_ntohs(rem_addr->sin_port));
+    pj_native_strcpy(rt_target_uri, target_url);
     rt_call_id = pj_str("RT-Call-Id/");
     rt_stop = PJ_FALSE;
@@ -552,5 +555,5 @@
     PJ_LOG(3,("", "    average round-trip=%d usec", usec_rt));
 
-    pjsip_endpt_destroy_pool(endpt, pool);
+    pjsip_endpt_release_pool(endpt, pool);
 
     if (is_reliable && (total_sent != total_recv)) {
